/* -----------------------------------------------------------------------------
 K03-21 Prevadec kodovani ceske diakritiky

 Martin Sloup, A04372
 FAV, INIB-INF
 msloup@students.zcu.cz
 arcao@arcao.com
 Soubor function.c
----------------------------------------------------------------------------- */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "function.h"
#include "structs.h"
#include "load_table.h"
#include "file_test.h"
#include "main.h"
#include "conv.h"

/* pokud se nenalezne potrebny znak, pouzije se tento */
#define CONV_UNKNOWN_CHAR ('?')

/**
 * Funkce na konverzi ASII <-> ASCII 
 */
void conv_ascii2ascii() {
	int ichar, new_char;
	int do_newline = 0;
	int prev_newline_char = -1;

/*
	for(ichar=0; ichar<table_length;ichar++) {
		printf("%d => %d\n", table[ichar].index, table[ichar].new_char);
	}
*/
	
	/* nacteme postupne vsechny znaky */
	while ((ichar = fgetc(fi)) != EOF) {
		ichar = char2int(ichar);

		/* pro znaky < 128 nastavime originalni hodnotu */
		new_char = (ichar < 128) ? ichar : -1;
		new_char = search_char(ichar, new_char);
		/* pokud se nepovedlo nalezt v konverzni tabulce vlozime otaznik */
		if (new_char == -1) new_char = char2int(CONV_UNKNOWN_CHAR);
		
		/* udelame novou radku*/
		if (do_newline == 1) {
			switch(param_newline_char) {
				case 1:
					fputc(fo, '\x0D');
					fputc(fo, '\x0A');
					break;
				case 2:
					fputc(fo, '\x0A');
					break;
				case 3:
					fputc(fo, '\x0D');
					break;
			}
			do_newline = 0;
			if (new_char == 0x0A && prev_newline_char == 0x0D) continue;
		}
		
		/* detekovali jsme novou radku, podle nastaveni provedeme vlozeni nove radky v dalsim cyklu */
		if (param_newline_char != 0 && do_newline == 0 && (new_char == 0x0A || new_char == 0x0D)) {
			prev_newline_char = new_char;
			do_newline = 1;
			continue;
		}
		/* ulozime novy znak do souboru */
		fputc(fo, int2char(new_char));
	}
	
	/* musime dat pozor na nove radky na konci souboru */
	if (do_newline == 1) {
		switch(param_newline_char) {
			case 1:
				fputc(fo, '\x0D');
				fputc(fo, '\x0A');
				break;
			case 2:
				fputc(fo, '\x0A');
				break;
			case 3:
				fputc(fo, '\x0D');
				break;
		}
		do_newline = 0;
	}
}

/**
 * Funkce na konverzi ASCII -> UTF-8
 */
void conv_ascii2utf8() {
	int ichar, new_char;
	int do_newline = 0;
	int prev_newline_char = -1;
	
	/* pokud uzivatel chce na zacatku utf-8 souboru BOM, vlozime ho tam */
	if (param_utf8_create_bom == 1) {
		fputc(fo, '\xEF');
		fputc(fo, '\xBB');
		fputc(fo, '\xBF');
	}
	
	
	/* nacteme postupne vsechny znaky */
	while ((ichar = fgetc(fi)) != EOF) {
		ichar = char2int(ichar);

		/* pro znaky < 128 nastavime originalni hodnotu */
		new_char = (ichar < 128) ? ichar : -1;
		new_char = search_char(ichar, new_char);
		/* pokud se nepovedlo nalezt v konverzni tabulce vlozime otaznik */
		if (new_char == -1) new_char = char2int(CONV_UNKNOWN_CHAR);

		/* udelame novou radku*/
		if (do_newline == 1) {
			switch(param_newline_char) {
				case 1:
					fputc(fo, '\x0D');
					fputc(fo, '\x0A');
					break;
				case 2:
					fputc(fo, '\x0A');
					break;
				case 3:
					fputc(fo, '\x0D');
					break;
			}
			do_newline = 0;
			if (new_char == 0x0A && prev_newline_char == 0x0D) continue;
		}
		
		/* detekovali jsme novou radku, podle nastaveni provedeme vlozeni nove radky v dalsim cyklu */
		if (param_newline_char != 0 && do_newline == 0 && (new_char == 0x0A || new_char == 0x0D)) {
			prev_newline_char = new_char;
			do_newline = 1;
			continue;
		}

		/* provedeme ulozeni unicode znaku v UTF-8 formatu */
		if (new_char < 0x80 ) {
			/* znaky < 128 ulozime primo */
			fputc(fo, int2char(new_char));
		/* pro dalsi pouzijeme specialni format */
		} else if (new_char < 0x800) {
			fputc(fo, int2char((new_char >> 6) + 192));
			fputc(fo, int2char((new_char & 63) + 128));
		} else if (new_char < 0x10000) {
			fputc(fo, int2char((new_char >> 12) + 224));
			fputc(fo, int2char(((new_char >> 6) & 63) + 128));
			fputc(fo, int2char((new_char & 63) + 128));
		} else if (new_char < 0x200000) {
			fputc(fo, int2char((new_char >> 18) + 240));
			fputc(fo, int2char(((new_char >> 12) & 63) + 128));
			fputc(fo, int2char(((new_char >> 6) & 63) + 128));
			fputc(fo, int2char((new_char & 63) + 128));
		} else {
			fputc(fo, CONV_UNKNOWN_CHAR);
		}	
	}
	
	/* musime dat pozor na nove radky na konci souboru */
	if (do_newline == 1) {
		switch(param_newline_char) {
			case 1:
				fputc(fo, '\x0D');
				fputc(fo, '\x0A');
				break;
			case 2:
				fputc(fo, '\x0A');
				break;
			case 3:
				fputc(fo, '\x0D');
				break;
		}
		do_newline = 0;
	}
}

/**
 * Funkce na konverzi UTF-8 -> ASCII
 */
void conv_utf82ascii() {
	int ichar, new_char, tmp_char;
	int do_newline = 0;
	int prev_newline_char = -1;
	
	/* nacteme postupne vsechny znaky */
	while ((ichar = fgetc(fi)) != EOF) {
		ichar = char2int(ichar); 
		/* konecna smycka jako nahrada goto */
		do {
			/* mame prvni znak, podle hodnoty se rozhodneme kolik znaku jeste je potreba nacist, aby jsme dostali unicode hodnotu */
			if (ichar < 128) {
				break;
			} else if (ichar >= 192 && ichar <= 223) {
				/* UTF-8 na dvou znacich */
				tmp_char = fgetc(fi);
				/* osetrime konec souboru */
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				tmp_char = char2int(tmp_char);
				ichar = ((ichar & 31) << 6) + (tmp_char & 63); 
			} else if (ichar >= 224 && ichar <= 239) {
				/* UTF-8 na tri znacich */
				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				tmp_char = char2int(tmp_char);
				ichar = ((ichar & 15) << 12) + ((tmp_char & 63) << 6);

				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				tmp_char = char2int(tmp_char);
				ichar += (tmp_char & 63);
			} else if (ichar >= 240 && ichar <= 247) {
				/* UTF-8 na ctyr znacich */
				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				ichar = ((ichar & 7) << 18) + ((tmp_char & 63) << 6);

				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				ichar += ((tmp_char & 63) << 6);

				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				ichar += (tmp_char & 63);
			}	
		} while(0);
		
		/* Detekovali jsme pocatecni nepoviny BOM - ignorujeme ho. */
		/* Pokud ho detekujeme uprostred souboru, mame ho podle doporuceni Unicode ignorovat. */
		if (ichar == 0xFEFF) continue;
		
		/* pro znaky < 128 nastavime originalni hodnotu */
		new_char = (ichar < 128) ? ichar : -1;
		new_char = search_char(ichar, new_char);
		/* pokud se nepovedlo nalezt v konverzni tabulce vlozime otaznik */
		if (new_char == -1) new_char = char2int(CONV_UNKNOWN_CHAR);

		/* udelame novou radku*/
		if (do_newline == 1) {
			switch(param_newline_char) {
				case 1:
					fputc(fo, '\x0D');
					fputc(fo, '\x0A');
					break;
				case 2:
					fputc(fo, '\x0A');
					break;
				case 3:
					fputc(fo, '\x0D');
					break;
			}
			do_newline = 0;
			if (new_char == 0x0A && prev_newline_char == 0x0D) continue;
		}
		
		/* detekovali jsme novou radku, podle nastaveni provedeme vlozeni nove radky v dalsim cyklu */
		if (param_newline_char != 0 && do_newline == 0 && (new_char == 0x0A || new_char == 0x0D)) {
			prev_newline_char = new_char;
			do_newline = 1;
			continue;
		}
		
		fputc(fo, new_char);
	}
	/* musime dat pozor na nove radky na konci souboru */
	if (do_newline == 1) {
		switch(param_newline_char) {
			case 1:
				fputc(fo, '\x0D');
				fputc(fo, '\x0A');
				break;
			case 2:
				fputc(fo, '\x0A');
				break;
			case 3:
				fputc(fo, '\x0D');
				break;
		}
		do_newline = 0;
	}
}

/**
 * Funkce na konverzi ASCII -> Unicode
 */
void conv_ascii2unicode() {
	int ichar, new_char;
	int do_newline = 0;
	int prev_newline_char = -1;
	
	/* podle nastaveni vlozime patricny BOM */
	if (param_unicode_bom == 1) {
		/* BOM - Big Endian */
		fputc(fo, '\xFE');
		fputc(fo, '\xFF');
	} else {
		/* BOM - Little Endian */
		fputc(fo, '\xFF');
		fputc(fo, '\xFE');
	}
	
	/* nacteme postupne vsechny znaky */
	while ((ichar = fgetc(fi)) != EOF) {
		ichar = char2int(ichar);

		/* pro znaky < 128 nastavime originalni hodnotu */
		new_char = (ichar < 128) ? ichar : -1;
		new_char = search_char(ichar, new_char);
		/* pokud se nepovedlo nalezt v konverzni tabulce vlozime otaznik */
		if (new_char == -1) new_char = char2int(CONV_UNKNOWN_CHAR);
		
		/* udelame novou radku*/
		if (do_newline == 1) {
			switch(param_newline_char) {
				case 1:
					if (param_unicode_bom == 1) fputc(fo, '\x00');
					fputc(fo, '\x0D');
					fputc(fo, '\x00');
					fputc(fo, '\x0A');
					if (param_unicode_bom == 0) fputc(fo, '\x00');
					break;
				case 2:
					if (param_unicode_bom == 1) fputc(fo, '\x00');
					fputc(fo, '\x0A');
					if (param_unicode_bom == 0) fputc(fo, '\x00');
					break;
				case 3:
					if (param_unicode_bom == 1) fputc(fo, '\x00');
					fputc(fo, '\x0D');
					if (param_unicode_bom == 0) fputc(fo, '\x00');
					break;
			}
			do_newline = 0;
			if (new_char == 0x0A && prev_newline_char == 0x0D) continue;
		}
		
		/* detekovali jsme novou radku, podle nastaveni provedeme vlozeni nove radky v dalsim cyklu */
		if (param_newline_char != 0 && do_newline == 0 && (new_char == 0x0A || new_char == 0x0D)) {
			prev_newline_char = new_char;
			do_newline = 1;
			continue;
		}

		/* podle nastaveni BOM provedeme ulozeni znaku ve spravnem poradi */
		if (param_unicode_bom == 1) {
			fputc(fo, int2char(new_char >> 8));
			fputc(fo, int2char(new_char & 0xFF));
		} else {
			fputc(fo, int2char(new_char & 0xFF));
			fputc(fo, int2char(new_char >> 8));
		}	
	}
	/* musime dat pozor na nove radky na konci souboru */
	if (do_newline == 1) {
		switch(param_newline_char) {
			case 1:
				if (param_unicode_bom == 1) fputc(fo, '\x00');
				fputc(fo, '\x0D');
				fputc(fo, '\x00');
				fputc(fo, '\x0A');
				if (param_unicode_bom == 0) fputc(fo, '\x00');
				break;
			case 2:
				if (param_unicode_bom == 1) fputc(fo, '\x00');
				fputc(fo, '\x0A');
				if (param_unicode_bom == 0) fputc(fo, '\x00');
				break;
			case 3:
				if (param_unicode_bom == 1) fputc(fo, '\x00');
				fputc(fo, '\x0D');
				if (param_unicode_bom == 0) fputc(fo, '\x00');
				break;
		}
		do_newline = 0;
	}
}

/**
 * Funkce na konverzi Unicode -> ASCII
 */
void conv_unicode2ascii() {
	int ichar, new_char, tmp_char;
	int do_newline = 0;
	int prev_newline_char = -1;
	
	/* nacteme postupne vsechny znaky */
	while ((ichar = fgetc(fi)) != EOF) {
		ichar = char2int(ichar); 
		/* potrebujeme jeste druhy znak */
		tmp_char = fgetc(fi);
		if (tmp_char == EOF) {
			ichar = char2int(CONV_UNKNOWN_CHAR);
		} else {
			/* podle nastaveni BOM spocitame unicode znak */
			if (param_unicode_bom == 1) {
				/* BOM - BE */
				ichar = (ichar << 8) + tmp_char;
			} else {
				/* BOM - LE */
				ichar = ichar + (tmp_char << 8);
			}
		}
		
		/* Detekovali jsme BOM znaky - nastvime chapani znaku podle BOM. */
		if (ichar == 0xFEFF || ichar == 0xFFFE) {
			if (param_unicode_bom == 1) {
				if (ichar == 0xFEFF) param_unicode_bom = 1;
				if (ichar == 0xFFFE) param_unicode_bom = 0;
			} else {
				if (ichar == 0xFEFF) param_unicode_bom = 0;
				if (ichar == 0xFFFE) param_unicode_bom = 1;
			}
			continue;
		}		
		
		/* pro znaky < 128 nastavime originalni hodnotu */
		new_char = (ichar < 128) ? ichar : -1;
		new_char = search_char(ichar, new_char);
		/* pokud se nepovedlo nalezt v konverzni tabulce vlozime otaznik */
		if (new_char == -1) new_char = char2int(CONV_UNKNOWN_CHAR);
		
		/* udelame novou radku*/
		if (do_newline == 1) {
			switch(param_newline_char) {
				case 1:
					fputc(fo, '\x0D');
					fputc(fo, '\x0A');
					break;
				case 2:
					fputc(fo, '\x0A');
					break;
				case 3:
					fputc(fo, '\x0D');
					break;
			}
			do_newline = 0;
			if (new_char == 0x0A && prev_newline_char == 0x0D) continue;
		}
		
		/* detekovali jsme novou radku, podle nastaveni provedeme vlozeni nove radky v dalsim cyklu */
		if (param_newline_char != 0 && do_newline == 0 && (new_char == 0x0A || new_char == 0x0D)) {
			prev_newline_char = new_char;
			do_newline = 1;
			continue;
		}
		
		fputc(fo, new_char);
	}
	/* musime dat pozor na nove radky na konci souboru */
	if (do_newline == 1) {
		switch(param_newline_char) {
			case 1:
				fputc(fo, '\x0D');
				fputc(fo, '\x0A');
				break;
			case 2:
				fputc(fo, '\x0A');
				break;
			case 3:
				fputc(fo, '\x0D');
				break;
		}
		do_newline = 0;
	}
}

/**
 * Funkce na konverzi UTF-8 -> Unicode
 */
void conv_utf82unicode() {
	int ichar, new_char, tmp_char;
	int do_newline = 0;
	int prev_newline_char = -1;
	
	/* podle nastaveni vlozime patricny BOM */
	if (param_unicode_bom == 1) {
		/* BOM - Big Endian */
		fputc(fo, '\xFE');
		fputc(fo, '\xFF');
	} else {
		/* BOM - Little Endian */
		fputc(fo, '\xFF');
		fputc(fo, '\xFE');
	}
	
	/* nacteme postupne vsechny znaky */
	while ((ichar = fgetc(fi)) != EOF) {
		ichar = char2int(ichar); 
		/* konecna smycka jako nahrada goto */
		do {
			/* mame prvni znak, podle hodnoty se rozhodneme kolik znaku jeste je potreba nacist, aby jsme dostali unicode hodnotu */
			if (ichar < 128) {
				break;
			} else if (ichar >= 192 && ichar <= 223) {
				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				tmp_char = char2int(tmp_char);
				ichar = ((ichar & 31) << 6) + (tmp_char & 63); 
			} else if (ichar >= 224 && ichar <= 239) {
				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				tmp_char = char2int(tmp_char);
				ichar = ((ichar & 15) << 12) + ((tmp_char & 63) << 6);

				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				tmp_char = char2int(tmp_char);
				ichar += (tmp_char & 63);
			} else if (ichar >= 240 && ichar <= 247) {
				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				ichar = ((ichar & 7) << 18) + ((tmp_char & 63) << 6);

				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				ichar += ((tmp_char & 63) << 6);

				tmp_char = fgetc(fi);
				if (tmp_char == EOF || (char2int(tmp_char) < 128 || char2int(tmp_char) > 191)) {
					ichar = char2int(CONV_UNKNOWN_CHAR);
					break;
				}
				ichar += (tmp_char & 63);
			}	
		} while(0);
		
		/* Detekovali jsme pocatecni nepoviny BOM - ignorujeme ho. */
		/* Pokud ho detekujeme uprostred souboru, mame ho podle doporuceni Unicode ignorovat. */
		if (ichar == 0xFEFF) continue;
		
		/* Uz mame unicode znak */
		new_char = ichar;

		/* udelame novou radku*/
		if (do_newline == 1) {
			switch(param_newline_char) {
				case 1:
					if (param_unicode_bom == 1) fputc(fo, '\x00');
					fputc(fo, '\x0D');
					fputc(fo, '\x00');
					fputc(fo, '\x0A');
					if (param_unicode_bom == 0) fputc(fo, '\x00');
					break;
				case 2:
					if (param_unicode_bom == 1) fputc(fo, '\x00');
					fputc(fo, '\x0A');
					if (param_unicode_bom == 0) fputc(fo, '\x00');
					break;
				case 3:
					if (param_unicode_bom == 1) fputc(fo, '\x00');
					fputc(fo, '\x0D');
					if (param_unicode_bom == 0) fputc(fo, '\x00');
					break;
			}
			do_newline = 0;
			if (new_char == 0x0A && prev_newline_char == 0x0D) continue;
		}
		
		/* detekovali jsme novou radku, podle nastaveni provedeme vlozeni nove radky v dalsim cyklu */
		if (param_newline_char != 0 && do_newline == 0 && (new_char == 0x0A || new_char == 0x0D)) {
			prev_newline_char = new_char;
			do_newline = 1;
			continue;
		}

		/* podle nastaveni BOM provedeme ulozeni znaku ve spravnem poradi */
		if (param_unicode_bom == 1) {
			fputc(fo, int2char(new_char >> 8));
			fputc(fo, int2char(new_char & 0xFF));
		} else {
			fputc(fo, int2char(new_char & 0xFF));
			fputc(fo, int2char(new_char >> 8));
		}	
	}
	/* musime dat pozor na nove radky na konci souboru */
	if (do_newline == 1) {
		switch(param_newline_char) {
			case 1:
				if (param_unicode_bom == 1) fputc(fo, '\x00');
				fputc(fo, '\x0D');
				fputc(fo, '\x00');
				fputc(fo, '\x0A');
				if (param_unicode_bom == 0) fputc(fo, '\x00');
				break;
			case 2:
				if (param_unicode_bom == 1) fputc(fo, '\x00');
				fputc(fo, '\x0A');
				if (param_unicode_bom == 0) fputc(fo, '\x00');
				break;
			case 3:
				if (param_unicode_bom == 1) fputc(fo, '\x00');
				fputc(fo, '\x0D');
				if (param_unicode_bom == 0) fputc(fo, '\x00');
				break;
		}
		do_newline = 0;
	}
}

/**
 * Funkce na konverzi Unicode -> UTF-8
 */
void conv_unicode2utf8() {
	int ichar, new_char, tmp_char;
	int do_newline = 0;
	int prev_newline_char = -1;
	
	/* pokud uzivatel chce na zacatku utf-8 souboru BOM, vlozime ho tam */
	if (param_utf8_create_bom == 1) {
		fputc(fo, '\xEF');
		fputc(fo, '\xBB');
		fputc(fo, '\xBF');
	}
	
	/* nacteme postupne vsechny znaky */
	while ((ichar = fgetc(fi)) != EOF) {
		ichar = char2int(ichar); 
		tmp_char = fgetc(fi);
		if (tmp_char == EOF) {
			ichar = char2int(CONV_UNKNOWN_CHAR);
			/*continue;*/
		} else {
			if (param_unicode_bom == 1) {
				/* BOM - BE */
				ichar = (ichar << 8) + tmp_char;
			} else {
				/* BOM - LE */
				ichar = ichar + (tmp_char << 8);
			}
		}
		
		/* Detekovali jsme BOM - nastvime chapani znaku podle BOM. */
		if (ichar == 0xFEFF || ichar == 0xFFFE) {
			if (param_unicode_bom == 1) {
				if (ichar == 0xFEFF) param_unicode_bom = 1;
				if (ichar == 0xFFFE) param_unicode_bom = 0;
			} else {
				if (ichar == 0xFEFF) param_unicode_bom = 0;
				if (ichar == 0xFFFE) param_unicode_bom = 1;
			}
			continue;
		}
		 
		/* Mame temer UTF-8 znak - staci provest konverzi znaku, viz nize */
		new_char = ichar;

		/* udelame novou radku*/
		if (do_newline == 1) {
			switch(param_newline_char) {
				case 1:
					fputc(fo, '\x0D');
					fputc(fo, '\x0A');
					break;
				case 2:
					fputc(fo, '\x0A');
					break;
				case 3:
					fputc(fo, '\x0D');
					break;
			}
			do_newline = 0;
			if (new_char == 0x0A && prev_newline_char == 0x0D) continue;
		}

		/* detekovali jsme novou radku, podle nastaveni provedeme vlozeni nove radky v dalsim cyklu */
		if (param_newline_char != 0 && do_newline == 0 && (new_char == 0x0A || new_char == 0x0D)) {
			prev_newline_char = new_char;
			do_newline = 1;
			continue;
		}
		
		/* provedeme ulozeni unicode znaku v UTF-8 formatu */
		if (new_char < 0x80 ) {
			/* znaky < 128 ulozime primo */
			fputc(fo, int2char(new_char));
		/* pro dalsi pouzijeme specialni format */
		} else if (new_char < 0x800) {
			fputc(fo, int2char((new_char >> 6) + 192));
			fputc(fo, int2char((new_char & 63) + 128));
		} else if (new_char < 0x10000) {
			fputc(fo, int2char((new_char >> 12) + 224));
			fputc(fo, int2char(((new_char >> 6) & 63) + 128));
			fputc(fo, int2char((new_char & 63) + 128));
		} else if (new_char < 0x200000) {
			fputc(fo, int2char((new_char >> 18) + 240));
			fputc(fo, int2char(((new_char >> 12) & 63) + 128));
			fputc(fo, int2char(((new_char >> 6) & 63) + 128));
			fputc(fo, int2char((new_char & 63) + 128));
		} else {
			fputc(fo, CONV_UNKNOWN_CHAR);
		}	
	}
	/* musime dat pozor na nove radky na konci souboru */
	if (do_newline == 1) {
		switch(param_newline_char) {
			case 1:
				fputc(fo, '\x0D');
				fputc(fo, '\x0A');
				break;
			case 2:
				fputc(fo, '\x0A');
				break;
			case 3:
				fputc(fo, '\x0D');
				break;
		}
		do_newline = 0;
	}
}
